SystemOrganization addCategory: #'DAO-SatelliteUI'!

WAComponent subclass: #DAOSatelliteControllerLauncher
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!DAOSatelliteControllerLauncher class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/28/2013 16:21'!
newWithController: aSatelliteController

	^self new initializeWithController: aSatelliteController  ! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/28/2013 16:23'!
initializeWithController: aSatelliteController

	controller := aSatelliteController 
! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/1/2013 13:41'!
shutDown
	ZnZincServerAdaptor stop 

! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/2/2013 17:05'!
startApp

	ZnZincServerAdaptor startOn: 8080.
	(WAAdmin register: SatelliteControlWebApp asApplicationAt: 'DAOSatelliteUI')
		addLibrary: PTDeploymentLibrary;
 	      addLibrary: SUDeploymentLibrary.
	! !

WAComponent subclass: #SatelliteControlWebComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

SatelliteControlWebComponent subclass: #CommandRequestUI
	instanceVariableNames: 'satelliteController subsystems subsystemName commandDefinition subsystem data response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandRequestUI class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/2/2013 17:23'!
newWithController: aSatelliteController
	^ self new initializeWithController: aSatelliteController! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 15:47'!
commandNamesForSubsystem: aSubsystem
	| commands commandNames |
	
	commands := aSubsystem commands.

	commandNames := commands keys.
	
	^ commandNames.! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 16:07'!
commandWithName: aCommandName
	^ subsystem commands at: aCommandName.! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 11/8/2013 19:19'!
data
	^ data ifNil: [ OrderedCollection new ].! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/2/2013 17:18'!
initialize
	super initialize.

	subsystems := OrderedCollection new.
	subsystems add: Subsystem thermal.
	subsystems add: Subsystem cdh.
	subsystems add: Subsystem memory.
	subsystems add: Subsystem platform.
	subsystems add: Subsystem power.
	! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/2/2013 17:04'!
initializeWithController: aSatelliteController 
	self initialize.
	satelliteController := aSatelliteController.	
	! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 11/9/2013 19:41'!
renderCommandListOn: html
	"Used by Prototype to update the list of commands"
	| commandNames commandsParametersId commandElementsId |
	
	commandElementsId := html nextId.
	commandsParametersId := html nextId.
	commandNames := self commandNamesForSubsystem: self subsystem.
	
	html label: 'Command: '.
	html select
			onChange: (html scriptaculous updater 
							id: commandsParametersId;
							triggerForm: commandElementsId;
			    	              callback: [ :ajaxHtml | self renderCommandParametersOn: ajaxHtml ]
						);
		callback: [ :value | commandDefinition := self commandWithName: value.
			data := (self commandWithName: value) requestDefinition];
		list: commandNames

! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 11/9/2013 18:31'!
renderCommandParametersOn: html
	"Used by Prototype to update the list of commands"
	| commandParameters |
	
	commandParameters :=  self data.
	
	commandParameters do: [ :each |
		html text: each name.
		html textInput 
			callback: [ :value | each value: value  ];
			value: each value . 
		html space.
		 ]! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 11/9/2013 19:48'!
renderContentOn: html
	| names form subsystemsElementId commandsElementId commandParametersId |

	names := subsystems collect: [:aSubsystem | aSubsystem name ].

	subsystemsElementId := html nextId.	
	commandsElementId := html nextId.
	commandParametersId := html nextId.

	html heading: 'Send Command' level: 4.
	
	form := html form.
	form class: 'pure-form pure-form-aligned'.
	form with: [
		html fieldSet: [
			html div class: 'pure-control-group';
				with: [ 
				      html label: 'Subsystem: '.
					html select
						id: subsystemsElementId;
				            list: names;
				            selected:  names first;
						"update the list with ID commandListElementId, executing renderCommandListOn: ajaxHtml "
						onChange: (html scriptaculous updater 
							id: commandsElementId;
							triggerFormElement: subsystemsElementId;
			    	              callback: [ :ajaxHtml | self renderCommandListOn: ajaxHtml ]
						);
						"set the subsystem name posted by the form, then the variable subsystem will be used by renderCommandListOn: ajaxHtml to select the available commands for that subystem"			
						callback: [ :value | subsystem := self subsystemWithName: value. ].
				].
			html div class: 'pure-control-group'; id: commandsElementId;
				with: [ self renderCommandListOn: html ].
			html div class: 'pure-control-group'; id: commandParametersId;
				with: [ self renderCommandParametersOn: html ].				
			html div class: 'pure-controls';				
				with: [ html submitButton class: 'pure-button'; on: #sendCommand of: self. ].
		].
	].
! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/2/2013 17:29'!
response
	^ response
	! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 11/8/2013 19:18'!
sendCommand
	response := satelliteController sendCommand: commandDefinition toSubsystem: subsystem withData: data.
	
	self answer.! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 15:43'!
subsystem
	^ subsystem ifNil: [ subsystems first ].! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 15:48'!
subsystemWithName: aSubsystemName
	^ subsystems detect: [ :each | each name = aSubsystemName ]! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/27/2013 17:50'!
subsystems
	^subsystems ! !

SatelliteControlWebComponent subclass: #SatelliteControlView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

SatelliteControlView subclass: #BeaconView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!BeaconView methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/28/2013 11:46'!
renderContentOn: html
	| subsystemName telemetryData |

	model data do: [ :telemetry |
		html definitionList: [ 
			subsystemName := telemetry key.
			html definitionTerm: subsystemName.
			telemetryData := telemetry value.
			telemetryData do: [ :data |
				html definitionData: data key, ':', data value printString.
			].
		].
	].! !

SatelliteControlView subclass: #CommandRequestView
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandRequestView methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/25/2013 11:59'!
renderContentOn: html
	model ifNotNil: [
		html label: 'Time: '.
		html text: model time printString.
		html break.
		html label: 'Subsystem: '.
		html text: model subsystem id.
		html break.
		html label: 'Command: '.
		html text: model commandId.
		html break.
		html label: 'Bytes: '.
		html text: bytes.
		html break.
	].! !

SatelliteControlView subclass: #CommandResponseView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandResponseView methodsFor: 'rendering' stamp: 'EmilianoMenendez 10/26/2013 16:02'!
renderContentOn: html
	html label: 'Time: '.
	html text: self model time printString.
	html break.
	html label: 'Data: '.
	html break.
	self model data do: [ :data |
		html text: data key, ':', data value printString.
		html break.
	].
	html label: 'Bytes: '.
	html text: self model bytes.
	html break.! !

SatelliteControlView subclass: #ControllerLogEntryView
	instanceVariableNames: 'commandName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!ControllerLogEntryView methodsFor: 'rendering' stamp: 'EmilianoMenendez 11/4/2013 13:30'!
renderContentOn: html
	| requestView responseView |

	html tableRow: [ 
		html tableData: self model sequenceNumber.
		html tableData: self model commandName.
		requestView := CommandRequestView model: self model request.
		html tableData: requestView.
		responseView := self viewFor: model response.
		html tableData: responseView.
	].
! !

!ControllerLogEntryView methodsFor: 'rendering' stamp: 'EmilianoMenendez 11/4/2013 13:30'!
viewFor: aModel
	| beaconNames responseView |

	beaconNames := Array with: 'Beacon' with: 'ShortBeacon'.

	responseView := CommandResponseView model: aModel.
	
	(beaconNames includes: aModel commandName) ifTrue: [ responseView := BeaconView model: aModel ].
	
	^ responseView
! !

SatelliteControlView subclass: #ControllerLogView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!ControllerLogView methodsFor: 'rendering' stamp: 'EzequielDavidovichCaballero 11/9/2013 21:59'!
filterLogWith
	^ true! !

!ControllerLogView methodsFor: 'rendering' stamp: 'EzequielDavidovichCaballero 11/9/2013 22:01'!
filterLogWith: aCriteria
	 ^ model logFilter: aCriteria! !

!ControllerLogView methodsFor: 'rendering' stamp: 'EzequielDavidovichCaballero 11/9/2013 21:56'!
renderContentOn: html
	| table form|
	
	html heading: 'Log' level: 4.
	form := html form.
	form class: 'pure-form pure-form-aligned'.
	form with:
[	
	table := html table.
	table class: 'pure-table pure-table-bordered'.
	table with: [
		html tableHead: [ 
			html tableRow: [ 
				html tableHeading: 'Sequence Number'.
				html tableHeading: 'Name'.
				html tableHeading: 'Request'.
				html tableHeading: 'Response'.
			].
		].
		model entries do: [ :logEntry | 
			html render: (ControllerLogEntryView model: logEntry).
		].
		html space.

		
		html text: 'CDH'.
		html checkbox 
		value: self filterLogWith;
            callback: [ :value | self filterLogWith: value ].
		html break.
		html text: 'Thermal'. 
		html checkbox 
		value: self filterLogWith;
            callback: [ :value | self filterLogWith: value ].
		html break.
		html text: 'Memory'. 
		html checkbox 
		value: self filterLogWith;
            callback: [ :value | self filterLogWith: value ].
		html break.
		html text: 'Platform'. 
		html checkbox 
		value: self filterLogWith;
            callback: [ :value | self filterLogWith: value ].
		html break.
		html text: 'Power'.
		html checkbox 
		value: self filterLogWith;
            callback: [ :value | self filterLogWith: value ].
		html break. ].
	
	
]

! !

!SatelliteControlView class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/28/2013 11:11'!
model: aCommandResponseModel
	^ self new initializeWithModel: aCommandResponseModel.! !

!SatelliteControlView methodsFor: 'initialization' stamp: 'EmilianoMenendez 10/28/2013 11:13'!
initializeWithModel: aModel
	super initialize.
	model := aModel.! !

!SatelliteControlView methodsFor: 'model' stamp: 'EmilianoMenendez 10/28/2013 11:11'!
model
	^ model! !

SatelliteControlWebComponent subclass: #SatelliteControlWebApp
	instanceVariableNames: 'satelliteController commandRequestView controllerLogView controllerLogFilterView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!SatelliteControlWebApp class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 12:05'!
canBeRoot
	^ true! !

!SatelliteControlWebApp class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/21/2013 12:26'!
initialize
	WAAdmin register: self asApplicationAt: 'satellitecontrol'! !

!SatelliteControlWebApp methodsFor: 'initialization' stamp: 'EzequielDavidovichCaballero 11/9/2013 21:40'!
children
	^ Array with: commandRequestView with: controllerLogView with: controllerLogFilterView .
! !

!SatelliteControlWebApp methodsFor: 'initialization' stamp: 'EmilianoMenendez 11/4/2013 13:08'!
initialize
	| satellite radio |
	
	super initialize.
	
"	satellite := SatelliteTest satelliteWithAllSubsystems.
	radio := SatelliteControllerRadioStub connectTo: satellite.
"	
	radio := SatelliteControllerRadio connectTo: #[127 0 1 1] port: 4445.
	
	satelliteController := SatelliteController newWith: radio.

	satelliteController inspect.

	self initializeChildren.! !

!SatelliteControlWebApp methodsFor: 'initialization' stamp: 'EmilianoMenendez 11/2/2013 18:04'!
initializeChildren
	commandRequestView := CommandRequestUI newWithController: satelliteController.
	controllerLogView := ControllerLogView model: satelliteController log.
! !

!SatelliteControlWebApp methodsFor: 'rendering' stamp: 'EmilianoMenendez 11/3/2013 02:59'!
renderContentOn: html
	html render: commandRequestView.
	html render: controllerLogView.
! !

!SatelliteControlWebComponent methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 11/3/2013 02:45'!
style
 	^ '.command-form {background-color: cf5e0b}'! !

!SatelliteControlWebComponent methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 21:09'!
updateRoot: anHtmlRoot
	| cssUrl |
	
	super updateRoot: anHtmlRoot.
	
	"cssUrl := 'http://seaside.st/styles/main.css'."
	cssUrl := 'http://yui.yahooapis.com/pure/0.3.0/pure-min.css'.
	
	anHtmlRoot stylesheet url: cssUrl.! !
SatelliteControlWebApp initialize!
